#include "stdafx.h"
#include <stdio.h>
#include "CppRuby.h"
#include "CppRubyExceptionHandler.h"

namespace CppRuby
{

  
VALUE 
ExceptionHandler::handleException()
{
  VALUE error = rb_gv_get("$!");
  return handleException( error );
}



#ifdef AFX_API

VALUE 
MfcExceptionHandler::handleException( Object error )
{
  CString message;
  String backtrace = Array(error.methodCall( "backtrace" )).join( "\n\t" );
  message.Format( "[ERROR] => Ruby exception:\n  %s\n\n  BackTrace:%s\n", 
                  error.to_s().c_str(),
                  backtrace.c_str() );
  ::OutputDebugString( message );
  ::AfxMessageBox( message, MB_OK|MB_ICONSTOP );
  return Qnil;
}

#endif


#ifdef WIN32

VALUE 
TraceExceptionHandler::handleException( Object error )
{
  CString message;
  String backtrace = Array(error.methodCall( "backtrace" )).join( "\n\t" );
  message.Format( "[ERROR] => Ruby exception:\n  %s\n\n  BackTrace:%s\n", 
                  error.inspect().c_str(),
                  backtrace.c_str() );
  ::OutputDebugString( message );
  return Qnil;
}

#endif


VALUE 
StdErrExceptionHandler::handleException( Object error )
{
  String backtrace = Array(error.methodCall( "backtrace" )).join( "\n\t" );
  fprintf( stderr, "Ruby exception:\n%s\n\nTrace:%s\n", 
                  error.inspect().c_str(),
                  backtrace.c_str() );
  return Qnil;
}


#ifdef WIN32
  typedef TraceExceptionHandler DefaultExceptionHandler;
#else
  typedef StdErrExceptionHandler DefaultExceptionHandler;
#endif


}  // namespace CppRuby
