// EditorFrame.cpp : implementation of the EditorFrame class
//

#include "stdafx.h"
#include "PraticalRuby.h"
#include "EditorFrame.h"
#include "MainFrame.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditorFrame

IMPLEMENT_DYNCREATE(EditorFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(EditorFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(EditorFrame)
		ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
		ON_WM_SETFOCUS()
		ON_WM_CREATE()
	ON_WM_CHILDACTIVATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditorFrame construction/destruction

EditorFrame::EditorFrame()
{
	// TODO: add member initialization code here
	
}

EditorFrame::~EditorFrame()
{
}

BOOL EditorFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

//	cs.style = WS_CHILD | WS_VISIBLE | WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
//		| FWS_ADDTOTITLE | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX;

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);

	return TRUE;
}

void EditorFrame::ActivateFrame(int nCmdShow)
{
	// TODO: Modify this function to change how the frame is activated.

	nCmdShow = SW_SHOWMAXIMIZED;
	CMDIChildWnd::ActivateFrame(nCmdShow);
}


/////////////////////////////////////////////////////////////////////////////
// EditorFrame diagnostics

#ifdef _DEBUG
void EditorFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void EditorFrame::Dump(CDumpContext& dc) const
{
  CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// EditorFrame message handlers
void EditorFrame::OnFileClose() 
{
  // To close the frame, just send a WM_CLOSE, which is the equivalent
  // choosing close from the system menu.

  SendMessage(WM_CLOSE);
}

int EditorFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
  if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
	  return -1;
  
  // create a view to occupy the client area of the frame
  if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, 
	  CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
  {
	  TRACE0("Failed to create view window\n");
	  return -1;
  }

  return 0;
}

void EditorFrame::OnSetFocus(CWnd* pOldWnd) 
{
  CMDIChildWnd::OnSetFocus(pOldWnd);

  m_wndView.SetFocus();
}

BOOL EditorFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
  // let the view have first crack at the command
  if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
	  return TRUE;
  
  // otherwise, do default handling
  return CMDIChildWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


BOOL 
EditorFrame::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
  // Forward Notification of Scintilla edit control to the edit control window...
  LPNMHDR notification = (LPNMHDR)lParam;
  if ( notification->hwndFrom == m_wndView.GetSafeHwnd() )
    return m_wndView.SendMessage( WM_NOTIFY, wParam, lParam );

  return CMDIChildWnd::OnNotify(wParam, lParam, pResult);
}


// Called when a MDI window is activated (or just moved)
// The wizard strangely does not propose that message for this class,
// though it is the only place it makes sense...
void 
EditorFrame::OnChildActivate() 
{
  CWnd ::OnChildActivate();

  mainFrame().windowActivated( m_wndView.editor() );
}


MainFrame &
EditorFrame::mainFrame()
{
  MainFrame *mainFrame = STATIC_DOWNCAST(MainFrame, AfxGetApp()->m_pMainWnd );
  return *mainFrame;
}


EditorView &
EditorFrame::view()
{
  return m_wndView;
}


void 
EditorFrame::OnClose() 
{
  // Need to be moved to ruby, but require dialog...

  if ( view().editor().safeMethodCall( "dirty?" ) != Qfalse )
  {
    CString name( CppRuby::String( view().editor().safeMethodCall( "title" ) ) );
    CString prompt;
    AfxFormatString1( prompt, AFX_IDP_ASK_TO_SAVE, name );
    switch ( AfxMessageBox( prompt, MB_YESNOCANCEL, AFX_IDP_ASK_TO_SAVE ) )
    {
    case IDCANCEL:
      return;
    case IDYES:
      if ( MainFrame::instance().executeCommand( ID_FILE_SAVE ) != Qtrue )
        return;
      break;
    }
  }

  MainFrame::instance().mainFrameObject().safeMethodCall( "removeEditorWindow",
                                                          view().editor() );
  
  CMDIChildWnd::OnClose();
}


void 
EditorFrame::updateTitle( const char *title )
{
  SetTitle( title );
  OnUpdateFrameTitle( TRUE );
}
