// EditorView.h : interface of the EditorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDITORVIEW_H__F5778314_3A15_4F23_8DEB_926F3D495637__INCLUDED_)
#define AFX_EDITORVIEW_H__F5778314_3A15_4F23_8DEB_926F3D495637__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CppRuby.h"
#include "RubyCppTools.h"
#include "GcCollectable.h"


/////////////////////////////////////////////////////////////////////////////
// EditorView window

class MainFrame;


class EditorView : public CWnd
                 , private GcCollectableOwner
{
// Construction
public:
  EditorView();

  CppRuby::Object editor();

// Attributes
public:
  LRESULT SendEditor( UINT Msg, WPARAM wParam=0, LPARAM lParam =0 );


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EditorView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~EditorView();

	// Generated message map functions
protected:
	//{{AFX_MSG(EditorView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
  void markGcCollectable( GcMarker &marker );

  void createRubyScintilla();

  MainFrame &mainFrame();

  CppRuby::Object m_rubyScintilla;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITORVIEW_H__F5778314_3A15_4F23_8DEB_926F3D495637__INCLUDED_)
