#ifndef CPPRUBY_GCCOLLECTABLE_H
#define CPPRUBY_GCCOLLECTABLE_H

#include <ruby.h>

class GcMarker
{
public:
  void mark( VALUE object );
};


/*! \brief Base class for object that reference ruby objects.
 */
class GcCollectableOwner
{
public:
  GcCollectableOwner();

  virtual ~GcCollectableOwner();

  /*! Called during mark phase.
   * 
   * For each reference the object has on ruby object, it should call
   * GcMarker::mark().
   */
  virtual void markGcCollectable( GcMarker &marker ) =0;
};


void Init_GcCollectableOwnerManager();


#endif // CPPRUBY_GCCOLLECTABLE_H