// MainFrame.h : interface of the MainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRAME_H__539D165D_C7D9_4FC3_A418_413D484B247D__INCLUDED_)
#define AFX_MAINFRAME_H__539D165D_C7D9_4FC3_A418_413D484B247D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "GcCollectable.h"
#include "CppRuby.h"

class EditorFrame;


class MainFrame : public CMDIFrameWnd
                , public GcCollectableOwner
{
	DECLARE_DYNAMIC(MainFrame)
public:
  MainFrame();

  static MainFrame &instance();

  CppRuby::Object mainFrameObject();

  void windowActivated( CppRuby::Object window );
  
  EditorFrame *newEditorWindow();

  CppRuby::Object executeCommand( unsigned int commandId );

// Attributes
public:

// Operations
public:

// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(MainFrame)
  public:
  virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
  protected:
  virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
  //}}AFX_VIRTUAL
// Implementation
public:
	virtual ~MainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
  virtual void OnUpdateFrameTitle( BOOL bAddToTitle );
  CStatusBar  m_wndStatusBar;
  CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(MainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
  struct MainFrameInitFunctor;
  void markGcCollectable( GcMarker &marker );


  CppRuby::Object m_mainFrame;
  HMENU m_hMDIMenu;
  HACCEL m_hMDIAccel;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRAME_H__539D165D_C7D9_4FC3_A418_413D484B247D__INCLUDED_)
