#include "stdafx.h"
#include "RubyExtEditControl.h"
#include "RubyExtScintilla.h"
#include "RubyTools.h"
#include "EditorFrame.h"


static VALUE
EditControl_SetTitle( VALUE self,
                      VALUE title )
{
  HWND window = reinterpret_cast<HWND>(Get_Scintilla_Window_Handle( self ));

  HWND frame = ::GetParent( window );
  if ( frame )
  {
    CWnd *window = CWnd::FromHandlePermanent( frame );
    if ( window )
    {
      EditorFrame *editorFrame = STATIC_DOWNCAST(EditorFrame, window);
      editorFrame->updateTitle( STR2CSTR( title ) );
    }
  }
  return Qnil;
}


void 
Init_EditControl()
{
  rb_require( "EditControl.rb" );
  ruby_define_method( ruby_get_class( "EditControl" ), 
                      "doSetTitle", 
                      EditControl_SetTitle, 
                      1 );
}
