#include "stdafx.h"
#include "RubyExtFileDialog.h"
#include "CppRuby.h"

// def FileDialog.doFileDialog( open
//                              filters, 
//                              defaultExtension, 
//                              fileName, 
//                              hideReadOnly, 
//                              multiSelect, 
//                              mustExist, 
//                              createPrompt, 
//                              overWritePrompt )
VALUE
FileDialog_DoFileDialog( VALUE self,
                         VALUE open,
                         VALUE filters,
                         VALUE defaultExtension,
                         VALUE fileName,
                         VALUE hideReadOnly,
                         VALUE multiSelect,
                         VALUE mustExist,
                         VALUE createPrompt,
                         VALUE overWritePrompt )
{
  DWORD flags = 0;
  flags |= ( hideReadOnly != Qfalse ) ? OFN_HIDEREADONLY : 0;
  flags |= ( multiSelect != Qfalse ) ? OFN_ALLOWMULTISELECT : 0;
  flags |= ( mustExist != Qfalse ) ? OFN_FILEMUSTEXIST : 0;
  flags |= ( createPrompt != Qfalse ) ? OFN_CREATEPROMPT : 0;
  flags |= ( overWritePrompt != Qfalse ) ? OFN_OVERWRITEPROMPT : 0;
  // Notes: need to enlarge buffer for mutli-select

  CString strFilters( STR2CSTR( filters ) );
  CString strDefaultExtension( STR2CSTR( defaultExtension ) );
  CString strFileName( STR2CSTR( fileName ) );

  CFileDialog dialog( open != Qfalse ? TRUE : FALSE,
                      strDefaultExtension,
                      strFileName,
                      flags,
                      strFilters );
  if ( dialog.DoModal() == IDOK )
  {
    if ( open != Qfalse )   // opening
    {
      CppRuby::Array fileNames = CppRuby::Array::newInstance();
      POSITION it = dialog.GetStartPosition();
      while ( it != NULL )
      {
        CString fullPath = dialog.GetNextPathName( it );
        fileNames.push( CppRuby::String( (LPCTSTR)fullPath ) );
      }
      return fileNames;
    }
    else
      return rb_str_new2( dialog.GetPathName() );
  }
  return Qnil;
}


void 
Init_FileDialog()
{
  rb_require( "FileDialog.rb" );
  ruby_define_module_function( ruby_get_class("FileDialog"),
                               "doFileDialog",
                               FileDialog_DoFileDialog, 9 );
}
