#define WIN32_LEAN_AND_MEAN 
#define NOGDI
#define NOKERNEL
#define NOSOUND
#define NOMINMAX
#include <windows.h>
#include <ruby.h>
#include "RubyTools.h"
#include "RubyExtTraceDebug.h"

extern "C" {

static VALUE
TraceDebug_Print( VALUE self, VALUE text )
{
  const char *message = STR2CSTR( rb_funcall( text, rb_intern("to_s"), 0 ) );

  ::OutputDebugString( message );

  return self;
}


void 
Init_TraceDebug()
{
  ruby_load( "TraceDebug.rb" );
  ruby_define_module_function( ruby_get_class( "TraceDebug" ), 
                               "internalPrint",
                               TraceDebug_Print, 
                               1 );
}



}  // extern "C"